<template>
	<div :class="$style.product">
		<div v-if="product.imageMobile || product.imageDesktop || product.image" :class="$style.imageWrapper">
			<div :class="$style.image">
				<BaseImage
					:image="product.imageMobile"
					:images="{ medium: product.imageDesktop || product.image }"
					compression-level="medium"
					sizes="(min-width: 1200px) 410px, (min-width: 768px) calc((100vw - 40px) / 3), calc(100vw - 40px)"
				/>
				<BlockWatermark
					v-if="product.watermarkImageDesktop"
					:image="product.watermarkImageMobile"
					:images="product.watermarkImageDesktop"
					:watermark-height="product.watermarkHeight || 100"
					:watermark-width="product.watermarkWidth || 50"
					:watermark-opacity="product.watermarkOpacity"
					:watermark-position="product.watermarkPosition || 'Center'"
				/>
			</div>
		</div>
		<h3 v-if="product.name" :class="$style.name">{{ product.name }}</h3>
		<p v-if="product.discount" :class="$style.discount">{{ `— Save ${currencySymbol}${product.discount} —` }}</p>
		<p v-if="!product.discount && product.savings" :class="$style.discount">{{ product.savings }}</p>

		<div :class="$style.finance">
			<BlockAffirm page-type="landing" :price="prices.currentPrice" @update="affirmUpdated" />
			<div v-if="prices.currentPrice < prices.listPrice" :class="$style.price">
				<span class="u-visuallyhidden">regular price</span>
				<span :class="$style.listPriceWrapper">{{ currencySymbol }}{{ prices.listPrice }}</span>
				<span class="u-visuallyhidden">sale price</span>
				<template v-if="prices.currentPrice">{{ currencySymbol }}{{ prices.currentPrice }}</template>
				<template v-else>&nbsp;</template>
			</div>
		</div>

		<div :class="$style.buttonWrapper">
			<BaseButton
				:smart="product.ctaLink && product.ctaLink.url"
				:target="product.ctaLink && product.ctaLink.target"
				size="medium"
			>
				{{ product.ctaText }}
			</BaseButton>
		</div>

		<div ref="affirmContainer" :class="$style.affirmContainer"></div>
	</div>
</template>

<script>
import { mapGetters } from 'vuex';
import BlockAffirm from '@components/block-affirm';
import BlockWatermark from '@components/block-watermark';

export default {
	components: {
		BlockAffirm,
		BlockWatermark,
	},

	props: {
		product: {
			type: Object,
			required: true,
		},
	},

	computed: {
		...mapGetters(['currencySymbol']),

		prices() {
			const { productOrBundle } = this.product;

			if (!productOrBundle && this.product.oldData) {
				return {
					currentPrice: this.product.oldData.price,
					listPrice: this.product.oldData.priceRegular,
				};
			}

			return { currentPrice: productOrBundle.currentPrice, listPrice: productOrBundle.listPrice };
		},
	},

	methods: {
		affirmUpdated(el) {
			const bottom = el.querySelector('.affirm-pmt-bottom');
			bottom.tabIndex = -1;
			if (bottom) {
				bottom.appendChild(document.createTextNode('. '));
				const trigger = el.querySelector('.affirm-modal-trigger');
				if (trigger) {
					bottom.appendChild(trigger);
				}

				const logo = bottom.querySelector('.__affirm-logo');
				if (logo) {
					logo.setAttribute('aria-hidden', 'true');
					logo.insertAdjacentHTML('afterend', '<span class="screen-reader-only">Affirm</span>');
				}

				const { affirmContainer } = this.$refs;
				if (!affirmContainer) return;
				while (affirmContainer.firstChild) {
					affirmContainer.removeChild(affirmContainer.firstChild);
				}
				affirmContainer.appendChild(bottom);
			}

			const month = el.querySelector('.affirm-ala-month');
			if (month) {
				const button = document.createElement('button');
				button.textContent = '*';
				button.addEventListener('click', () => bottom.focus());
				month.appendChild(button);
			}
		},
	},
};
</script>

<style lang="scss" module>
@import '@design';

.product {
	display: flex;
	flex: 0 0 auto;
	flex-direction: column;
	width: 100%;
}

.name,
.finance,
.discount {
	@include use-text-style('heading-150');

	font-weight: 300;
}

.name {
	@include font-family('secondary');

	margin: 2.4rem 0 -0.2rem;

	@include above('medium') {
		margin: 1.05rem 0 -0.4rem;
	}
}

.discount {
	margin: 0 0 2.7rem;

	@include above('medium') {
		margin: 0 0 2.26rem;
	}
}
.finance {
	margin-bottom: size('s');
	font-weight: 300;

	@include above('medium') {
		margin-bottom: 0.9rem;
	}
}

.listPriceWrapper {
	color: color('primary-200');
	text-decoration: line-through;
	text-decoration-color: color('red');
}

.buttonWrapper {
	margin-bottom: 4.2rem;

	@include above('medium') {
		margin-bottom: 4.65rem;
	}
}

.imageWrapper {
	position: relative;
	display: flex;
	justify-content: center;
}

.image {
	display: flex;
	flex: 0 1 33rem;
	align-items: flex-end;

	@include above('medium') {
		flex: 0 1 29.9rem;
	}
}

.affirmContainer {
	margin-bottom: size('m');
	font-weight: 300;

	@include use-text-style('type-100');

	@include above('medium') {
		margin-bottom: 5.2rem;
	}

	&:empty {
		display: none;
	}

	:global(.affirm-pmt-bottom) {
		&::before {
			content: '*';
		}
	}

	:global(.affirm-modal-trigger) {
		font-weight: 400;
	}
}
</style>
